<template>
  <div class="q-pa-md">
    <q-table
      title="Contents"
      :data="contents"
      row-key="id"
      :columns="columns"
      selection="multiple"
      :selected.sync="selected"
      
    >
       
     
        <template v-slot:header-selection="scope">
        <q-toggle v-model="scope.selected" />
      </template>
        <template v-slot:body="contents">
            <q-tr :contents="contents">
                <q-td auto-width>
                    <q-toggle dense v-model="contents.selected" ></q-toggle>
                </q-td>
                <q-td key="index" :contents="contents" align="left">
                    {{ contents.row.index }}
                </q-td>
                <q-td key="name" :contents="contents" align="left">
                    {{ contents.row.name }}
                </q-td>
                <q-td key="text" :contents="contents" align="left">
                    <q-btn dense round flat :icon="contents.expand ? 'arrow_drop_up' : 'arrow_drop_down'" @click="contents.expand = !contents.expand" ></q-btn>
                </q-td>
                <q-td key="category" :contents="contents" align="left">
                    {{contents.row.category.name}}
                </q-td>
                <q-td key="object" :contents="contents" align="left">
                    {{contents.row.object.name}}
                </q-td>
                <q-td key="action" :contents="contents" class="q-td" align="left" width="200px">
                    <q-btn
                        color="primary"
                        icon="edit"
                        @click="ShowEditModal(contents.row)"
                        size="sm"
                        danse
                        class="q-ml-sm"
                    />
                    <q-btn
                        color="red"
                        icon="delete"
                        @click="ShowDeleteModal(contents.row)"
                        size="sm"
                        danse
                        class="q-ml-sm"
                    />
                </q-td>
            </q-tr>
            <q-tr v-show="contents.expand" :contents="contents" class="myclass">
                <q-td colspan="100%" :style="{width: '400px', whiteSpace: 'normal'}">
                    
                    {{contents.row.text}}
                   
                </q-td>
            </q-tr>
            
        </template>
       
      
      <template v-slot:top>
        <q-btn
          color="primary"
          label="Add Content"
          @click="ShowAddModal()"
        />

        <q-btn
          v-if="selected.length"
          class="q-ml-sm"
          color="negative"
          label="Delete Content"
          @click="ShowMoreDeleteModal()"
        />
        
       
        <q-space />
        <q-input
          dense
          rounded
          standout="bg-info text-white"
          v-model="search_text"
          v-on:keyup="filterFn"
          input-class="text-right"
          class="q-ml-md"
        >
          <template v-slot:append>
            <q-icon v-if="search_text === ''" name="search" />
            <q-icon
              v-else
              name="clear"
              class="cursor-pointer"
              @click="filter"
            />
          </template>
        </q-input>
      </template>
    </q-table>

    <!-- Modallar Dialog -->
    <!-- Add Dialog -->
    <q-dialog v-model="AddModal" persistent>
  
      <q-layout view="hHh lpR fFf" container style="max-width: 350px; height:500px" class=" q-mb-md rounded-borders bg-white">
        <q-header class="bg-white">
        
          <q-toolbar>
            <!-- <q-btn flat round dense icon="menu" /> -->
            <q-toolbar-title align="center"  class="text-primary bg-white">
              <div class="text-h6">New Content</div>
            </q-toolbar-title>
          </q-toolbar>
        </q-header>

      

        <q-page-container>
          <q-page class="bg-white">
            
            <q-card-section class="q-pt-none">
              <div class="text-h7">Name</div>
              <q-input dense v-model="AddData.name" autofocus />
            </q-card-section>
            <q-card-section class="q-pt-none">
                <div class="text-h7">Text</div>
                <q-input
                    v-model="AddData.text"
                    filled
                    autofocus
                    type="textarea"
                    />
            </q-card-section>
            <q-card-section class="q-pt-none">
                <div class="text-h7">Category</div>
                <br>
                <q-select
                    filled
                    v-model="AddData.category_id"
                    :options="categorys"
                    label="Select Category"
                    emit-value
                    map-options
                />
            </q-card-section>
            <q-card-section class="q-pt-none">
                <div class="text-h7">Objects</div>
                <br>
                <q-select
                    filled
                    v-model="AddData.object_id"
                    :options="object"
                    label="Select Objects"
                    emit-value
                    map-options
                />
            </q-card-section>
          </q-page>
        </q-page-container>
        <q-footer  >
          <q-toolbar class="bg-white">
            <!-- <q-btn flat round dense icon="menu" /> -->
            <q-toolbar-title align="right"  class="text-primary bg-write bg-white">
              <q-btn flat label="Create" @click="SendAddData"/>
              <q-btn flat label="Cancel" @click="CloseAddModle()"/>
            </q-toolbar-title>
          </q-toolbar>
        </q-footer>
      </q-layout>
    </q-dialog>
    <!-- End Add Dialog -->

    <!-- Edit Dialog -->
    <q-dialog v-model="EditModal" persistent>
  
      <q-layout view="hHh lpR fFf" container style="max-width: 350px; height:500px" class=" q-mb-md rounded-borders bg-white">
        <q-header class="bg-white">
        
          <q-toolbar>
            <!-- <q-btn flat round dense icon="menu" /> -->
            <q-toolbar-title align="center"  class="text-primary bg-white">
              <div class="text-h6">Ubdate Content</div>
            </q-toolbar-title>
          </q-toolbar>
        </q-header>

      

        <q-page-container>
          <q-page class="bg-white">
            
            <q-card-section class="q-pt-none">
              <div class="text-h7">Name</div>
              <q-input dense v-model="EditData.name" autofocus />
            </q-card-section>
            <q-card-section class="q-pt-none">
                <div class="text-h7">Text</div>
                <q-input
                    v-model="EditData.text"
                    filled
                    autofocus
                    type="textarea"
                    />
            </q-card-section>
            <q-card-section class="q-pt-none">
                <div class="text-h7">Category</div>
                <br>
                <q-select
                    filled
                    v-model="EditData.category_id"
                    :options="categorys"
                    label="Select Category"
                    emit-value
                    map-options
                />
            </q-card-section>
            <q-card-section class="q-pt-none">
                <div class="text-h7">Objects</div>
                <br>
                <q-select
                    filled
                    v-model="EditData.object_id"
                    :options="object"
                    label="Select Objects"
                    emit-value
                    map-options
                />
            </q-card-section>
          </q-page>
        </q-page-container>
        <q-footer  >
          <q-toolbar class="bg-white">
            <!-- <q-btn flat round dense icon="menu" /> -->
            <q-toolbar-title align="right"  class="text-primary bg-write bg-white">
              <q-btn flat label="Create" @click="SendEditData"/>
              <q-btn flat label="Cancel" @click="CloseEditModle()"/>
            </q-toolbar-title>
          </q-toolbar>
        </q-footer>
      </q-layout>
    </q-dialog>
    <!-- End Edit Dialog -->

    <!-- Delete Dialog -->
    <q-dialog v-model="DeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="SendDeleteData"
        @keyup.esc="DeleteModal = false"
      >
        <q-card-section>
          <div class="text-h6">Delete Contents</div>
        </q-card-section>

        <q-card-section>
          <div class="text-h7">You agree to delete this information?</div>
        </q-card-section>
        <q-card-section>
          <div class="text-h7">Name:{{ DeleteData.name }}</div>
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="negative" label="Delete" @click="SendDeleteData" />
          <q-btn flat label="Cancel" @click="DeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Delete Dialog -->
    <!-- Start Multi Delete Modal  -->
    <q-dialog v-model="multiDeleteModal" persistent>
      <q-card
        style="min-width: 350px;"
        @keyup.enter="selected.id"
        @keyup.esc="multiDeleteModal = false"
      >
        <q-card-section class="bg-deep-orange text-white">
          <div class="text-h6">Are you sure delete this Contents ?</div>
        </q-card-section>
        <q-form id="validates">
          <q-card-section class="q-pt-md">
            <div v-for="(selects, i) in selected" :key="i">
              <div class="row">
                <div class="row">
                  <p class="text-weight-bold q-pr-sm">{{ i + 1 }}. Name :</p>
                  {{ selects.name }}
                </div>
              </div>
            </div>
          </q-card-section>
        </q-form>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="red" label="Delete" @click="sendmultiDelete" />
          <q-btn flat label="Cancel" @click="multiDeleteModal = false" />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Multi Delete Modal  -->
  </div>
</template>

<script>
import axios from 'axios'
import { Notify } from 'quasar'

export default {
  name: 'PageIndex',
  data() {
    return {
        password_error: false,
        search_text: '',
        categorys: [],
        object:[],
        contents: [],
        allcontents: [],
        selected: [],
        columns: [
            {
            name: 'index',
            label: '#',
            field: 'index',
            align: 'left',
            style: 'width: 10px',
            sortable: true,
            },
            {
            name: 'name',
            field: 'name',
            label: 'Name',
            align: 'left',
            sortable: true,
            },
            {
            name: 'text',
            field: 'text',
            label: 'Text',
            align: 'left',
            sortable: true,
            style: 'width: 200px !important',
            },
            {
            name: 'category',
            field: row=>row.category.name,
            label: 'Category Name',
            align: 'left',
            sortable: true,
            },
            {
            name: 'object',
            field: 'object',
            label: 'Object',
            align: 'left',
            sortable: true,
            },
            {
            name: 'action',
            label: 'Action',
            align: 'left',
            style: 'width: 20px !important',
            },
        ],
        AddModal: false,
        AddData: {
            id: '',
            name: '',
            text: '',
            category_id: '',
            object_id: '',
        },
        EditModal: false,
        EditData: [],
        DeleteModal: false,
        DeleteData: [],
        multiDeleteModal:false
    }
  },
  async mounted() {
    this.$q.loading.show()
    this.getcontent()
    this.category()
    this.objects()
    this.$q.loading.hide()

  },

  methods: {
    async getcontent() {
      await axios
        .get('http://127.0.0.1:10/api/content/')
        .then((response) => {
          var data = response.data
          this.contents=[]
          let j=[]
          for (var i = 0; i < data.length; i++) {
            var json = {
              index: i+1,
              id: data[i].id,
              name: data[i].name,
              text: data[i].text,
              object:data[i].object,
              category:data[i].category
            }
            this.contents.push(json)
            this.allcontents=this.contents
            // console.log(this.contents)
          }
        })
        .catch((e) => {
          var res = e.response
          this.$q.loading.hide()
          Notify.create({
              type: 'negative',
              message: 'Something Error',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        })
    },
    async category() {
      await axios
        .get('http://127.0.0.1:10/api/category/get_category')
        .then((response) => {
          var data = response.data

          console.log(response.data)

          for (var i = 0; i < data.length; i++) {
            var json = {
              value: data[i].id,
              label: data[i].name,
            }
            this.categorys.push(json)
          }
           
        })
        .catch((e) => {
          var res = e.response
          this.$q.loading.hide()
          
          Notify.create({
              type: 'negative',
              message: 'Something Error',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
          
        })
    },
    async objects() {
      await axios
        .get('http://127.0.0.1:10/api/objects/')
        .then((response) => {
          var data = response.data
          console.log(response.data)
          for (var i = 0; i < data.length; i++) {
            var json = {
              value: data[i].id,
              label: data[i].name,
            }
            this.object.push(json)
          }
           
        })
        .catch((e) => {
          this.$q.loading.hide()
          Notify.create({
              type: 'negative',
              message: 'Something Error',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        })
    },
    ShowAddModal() {
      this.AddModal = true
    },
    async SendAddData() {
       if (this.AddData.name.length < 3) {
         Notify.create({
              type: 'negative',
              message: 'The name must be at least 3 characters.',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        
        return 0
      }
       if (this.AddData.text.length < 10) {
         Notify.create({
              type: 'negative',
              message: 'The name must be at least 10 characters.',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        return 0
      }
       if (this.AddData.category_id.length < 1) {
         Notify.create({
              type: 'negative',
              message: 'The category not',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        return 0
      }
       if (this.AddData.object_id.length < 1) {
         Notify.create({
              type: 'negative',
              message: 'The object not',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        return 0
      }
      this.$q.loading.show()
      await axios
        .post(
          'http://127.0.0.1:10/api/content/create_content',
          this.AddData
        )
        .then((res) => {
          //console.log(res.msg)
          if (res.status == 201) {
            Notify.create({
                    type: 'positive',
                    message: 'Succesfully Create Content Data',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
          this.AddData = {
              id: '',
              name: '',
          }
            this.AddModal = false
            this.getcontent()
            this.$q.loading.hide()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          Notify.create({
              type: 'negative',
              message: 'Something Error',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        })
      
      this.$q.loading.hide()
    },
   
    ShowEditModal(data) {
      this.EditModal = true
      this.EditData = {
        id: data.id,
        name: data.name,
        text: data.text,
        category_id: data.category.id,
        object_id: data.object.id,
      }
      console.log(this.EditData)

    },
    async SendEditData() {
       if (this.EditData.name.length < 3) {
         Notify.create({
              type: 'negative',
              message: 'The name must be at least 3 characters.',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        
        return 0
      }
       if (this.EditData.text.length < 10) {
         Notify.create({
              type: 'negative',
              message: 'The name must be at least 10 characters.',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        return 0
      }
       if (this.EditData.category_id.length < 1) {
         Notify.create({
              type: 'negative',
              message: 'The category not',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        return 0
      }
       if (this.EditData.object_id.length < 1) {
         Notify.create({
              type: 'negative',
              message: 'The object not',
              position: "bottom-right",
              progress: true,
              actions: [
                  { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
              ]
          })
        return 0
      }
     
      this.$q.loading.show()
      console.log(this.EditData);
      await axios
        .post(
          'http://127.0.0.1:10/api/content/update_content',
          this.EditData,
        )
        .then((res) => {
          
          if (res.status == 200) {
            Notify.create({
                    type: 'positive',
                    message: 'Succesfully Update Content Data',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
            this.EditModal = false
            this.$q.loading.hide()
            this.getcontent()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          
          Notify.create({
            type: 'negative',
            message: 'The category not',
            position: "bottom-right",
            progress: true,
            actions: [
                { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
            ]
          })
          
        })

      this.$q.loading.hide()
    },
    ShowDeleteModal(content) {
      this.DeleteData = {
        id: content.id,
        name: content.name,
      }
      this.DeleteModal = true
    },
    async SendDeleteData() {
      this.$q.loading.show()
      await axios
        .post(
          'http://127.0.0.1:10/api/content/delete_content',
          this.DeleteData,
        )
        .then((res) => {
          //console.log(res.msg)

          if (res.status == 200) {
            Notify.create({
                    type: 'positive',
                    message: 'Succesfully Delete content',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
            this.DeleteModal = false
            this.getcontent()
          }
        })
        .catch((e) => {
          this.$q.loading.hide()
          var res = e.response
          
           
          Notify.create({
            type: 'negative',
            message: 'The category not',
            position: "bottom-right",
            progress: true,
            actions: [
                { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
            ]
          })
          
        })

      this.$q.loading.hide()
    },
    CloseAddModle() {
      this.AddModal = false
      this.AddData = {
        id: '',
        name: '',
      }
    },
    CloseEditModle() {
      this.EditModal = false
      this.EditData = []
    },
    ShowMoreDeleteModal() {
      this.multiDeleteModal = true
    },
    async sendmultiDelete() {
      this.$q.loading.show()
      let sender = JSON.stringify(this.selected)
      await axios
        .post('http://127.0.0.1:10/api/content/multidelete', {
          data: sender,
        })
        .then((res) => {
          //console.log(res.msg)
          if (res.status == 200) {
            Notify.create({
                    type: 'positive',
                    message: 'Succesfully Delete contents',
                    position: "bottom-right",
                    progress: true,
                    actions: [
                        { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
                    ]
                })
            this.multiDeleteModal = false
            this.getcontent()
          }
        })
        .catch((e) => {
          Notify.create({
            type: 'negative',
            message: 'The category not',
            position: "bottom-right",
            progress: true,
            actions: [
                { icon: 'close', size: "sm", color: 'white', handler: () => { /* ... */ } }
            ]
          })
        })
      this.selected=[]
      this.$q.loading.hide()
    },
    filterFn(){
        this.contents=this.allcontents.filter(v=>v.name.toLowerCase().indexOf(this.search_text.toLowerCase()) > -1)
    },
    filter(){
      this.contents=this.allcontents
      this.search_text=''
    }
  },
}
</script>
<style scoped>


.q-table tbody td {
    white-space: normal;
}
</style>